package com.reglamb.projvehimerc.domain;

import java.io.Serializable;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

@Entity
@SequenceGenerator(
	    name="SEQ_STORE",
	    sequenceName="sequencevehicularinscripcion",
	    initialValue= 100 ,
	    allocationSize=20)
@Table(name = "`HABILITACIONVEHICULAR_INSCRIPCION`")
public class HabilitacionVehicular_Inscripcion implements Serializable,DomainObject{

	private static final long serialVersionUID = 1L;
	private Long idhabilitacionvehicularid;
	private Long numsisgedo;
	private Long numrecibobanc;
	private byte nominaconductores;
	private byte copiasimpltarjeta;
	private byte nominavehiculo;
	private byte copiasimplcitv;
	private byte copiasoat;
	private Transportista transportista;
	private byte[] actacertificacion;

	@Id
	@GeneratedValue(strategy=GenerationType.SEQUENCE, generator="SEQ_STORE")
	@Column(name="`Id_Habilitacionvehicular`")
	public Long getIdhabilitacionvehicularid() {
		return idhabilitacionvehicularid;
	}
	public void setIdhabilitacionvehicularid(Long idhabilitacionvehicularid) {
		this.idhabilitacionvehicularid = idhabilitacionvehicularid;
	}
	public Long getNumsisgedo() {
		return numsisgedo;
	}
	public void setNumsisgedo(Long numsisgedo) {
		this.numsisgedo = numsisgedo;
	}
	public Long getNumrecibobanc() {
		return numrecibobanc;
	}
	public void setNumrecibobanc(Long numrecibobanc) {
		this.numrecibobanc = numrecibobanc;
	}
	public byte getNominaconductores() {
		return nominaconductores;
	}
	public void setNominaconductores(byte nominaconductores) {
		this.nominaconductores = nominaconductores;
	}
	public byte getCopiasimpltarjeta() {
		return copiasimpltarjeta;
	}
	public void setCopiasimpltarjeta(byte copiasimpltarjeta) {
		this.copiasimpltarjeta = copiasimpltarjeta;
	}
	public byte getNominavehiculo() {
		return nominavehiculo;
	}
	public void setNominavehiculo(byte nominavehiculo) {
		this.nominavehiculo = nominavehiculo;
	}
	public byte getCopiasimplcitv() {
		return copiasimplcitv;
	}
	public void setCopiasimplcitv(byte copiasimplcitv) {
		this.copiasimplcitv = copiasimplcitv;
	}
	public byte getCopiasoat() {
		return copiasoat;
	}
	public void setCopiasoat(byte copiasoat) {
		this.copiasoat = copiasoat;
	}
	@OneToOne (mappedBy="habilitacionvehicularinscripcion")
	public Transportista getTransportista() {
		return transportista;
	}
	public void setTransportista(Transportista transportista) {
		this.transportista = transportista;
	}
	@Lob
	@Basic(fetch=javax.persistence.FetchType.LAZY)
	public byte[] getActacertificacion() {
		return actacertificacion;
	}
	public void setActacertificacion(byte[] actacertificacion) {
		this.actacertificacion = actacertificacion;
	}

}
