package com.reglamb.projvehimerc.domain;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;


/**s 
 * @author  banktsu
 */

@Entity
@GenericGenerator(name="SEQ_STORE", strategy = "org.hibernate.id.enhanced.SequenceStyleGenerator",
		parameters = { @Parameter(name = "sequence_name", value = "sequencetransportista"), 
		@Parameter(name = "initial_value", value ="1000000"), 
		@Parameter(name = "increment_size", value ="100") })
@Table(name ="TRANSPORTISTA")
@Inheritance(strategy = InheritanceType.TABLE_PER_CLASS)
//@Inheritance(strategy=InheritanceType.JOINED), diferent tables and properties of one subclasses diferent of others.
public abstract class Transportista implements Serializable,DomainObject{
	private static final long serialVersionUID = 1L;
	private Long idtransportista;
	private int ruc;
	private String tipodocumento;
	private int numerodocumento;
	private String referencias;
	private String telefono;
	private String email;
	private String objectosocial;
	private String zonaoperacion;
	private Set<Transportista_Ubigeo> ubigeoTransportistas = new HashSet<Transportista_Ubigeo>();
	private Set<Vehiculo> vehiculo = new HashSet<Vehiculo>();
	private Set<Conductor> conductor = new HashSet<Conductor>();
	private HabilitacionVehicular_Inscripcion habilitacionvehicularinscripcion;
	 @Id
	 @GeneratedValue(strategy=GenerationType.SEQUENCE, generator="SEQ_STORE")	 
	 @Column(name = "`Id_transportista`")
	public Long getIdtransportista() {
		return idtransportista;
	}
	public void setIdtransportista(Long idtransportista) {
		this.idtransportista = idtransportista;
	}
	public int getRuc() {
		return ruc;
	}
	public void setRuc(int ruc) {
		this.ruc = ruc;
	}
	@Column(name = "`TipodeDocumento`")
	  /*,unique=true,
    nullable=false,
    length=32)*/
	public String getTipodocumento() {
		return tipodocumento;
	}
	public void setTipodocumento(String tipodocumento) {
		this.tipodocumento = tipodocumento;
	}
	public int getNumerodocumento() {
		return numerodocumento;
	}
	public void setNumerodocumento(int numerodocumento) {
		this.numerodocumento = numerodocumento;
	}
	public String getReferencias() {
		return referencias;
	}
	public void setReferencias(String referencias) {
		this.referencias = referencias;
	}
	public String getTelefono() {
		return telefono;
	}
	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getObjectosocial() {
		return objectosocial;
	}
	public void setObjectosocial(String objectosocial) {
		this.objectosocial = objectosocial;
	}
	
	@OneToMany(targetEntity=Transportista_Ubigeo.class,
			orphanRemoval = true,cascade={javax.persistence.CascadeType.ALL})
	//@SuppressWarnings("deprecation")
	//@OneToMany(targetEntity=Transportista_Ubigeo.class)
	//@OneToOne (cascade={javax.persistence.CascadeType.ALL},orphanRemoval = true)
	@JoinTable(name = "TransportistaUbigeo",joinColumns = {
	@JoinColumn(name="`Id_transportista_ubigeo`")})
	/*One To Many , is relation like agregation, parent to child*/
	//@Cascade (value={CascadeType.SAVE_UPDATE,CascadeType.DELETE_ORPHAN})
	public Set<Transportista_Ubigeo> getUbigeoTransportista() {
		return ubigeoTransportistas;
	}
	
	public void setUbigeoTransportista(Set<Transportista_Ubigeo> ubigeoTransportistas) {
		this.ubigeoTransportistas = ubigeoTransportistas;
	}
	/*Vehiculo ---->*/
	@OneToMany(targetEntity=Vehiculo.class,
			orphanRemoval = true,cascade={javax.persistence.CascadeType.ALL})
			@JoinColumn(name="`Id_Vehiculo`")
	public Set<Vehiculo> getVehiculo() {
		return vehiculo;
	}
	public void setVehiculo(Set<Vehiculo> vehiculo) {
		this.vehiculo = vehiculo;
	}
	
	@Column(name = "`ZONA_OPERACION`")
	public String getZonaoperacion() {
		return zonaoperacion;
	}
	public void setZonaoperacion(String zonaoperacion) {
		this.zonaoperacion = zonaoperacion;
	}
	@OneToMany(targetEntity=Conductor.class,
			cascade={javax.persistence.CascadeType.ALL},orphanRemoval = true)
	/*@JoinTable(name = "TransportistaConductor",joinColumns = {
	@JoinColumn(name="`Id_transportista`",nullable=false)})*/
	@JoinColumn(name="`Id_transportista`",nullable=false)
	public Set<Conductor> getConductor() {
		return conductor;
	}
	public void setConductor(Set<Conductor> conductor) {
		this.conductor = conductor;
	}
	
	/*Habilitacion Vehicular*/
	@OneToOne(cascade={javax.persistence.CascadeType.ALL},orphanRemoval = true)
	@JoinColumn (name="`Id_Habilitacionvehicular`")
	/*@JoinTable (name="TransportistaHabilitacion",
			joinColumns=@JoinColumn(name="`Id_transportista`"),
			inverseJoinColumns=@JoinColumn(name="`Id_Habilitacionvehicular`"))*/
	public HabilitacionVehicular_Inscripcion getHabilitacionvehicularinscripcion() {
		return habilitacionvehicularinscripcion;
	}
	public void setHabilitacionvehicularinscripcion(
			HabilitacionVehicular_Inscripcion habilitacionvehicularinscripcion) {
		this.habilitacionvehicularinscripcion = habilitacionvehicularinscripcion;
	}
	
	
}
