package com.reglamb.projvehimerc.domain;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import com.reglamb.projvehimerc.domain.transportista.Transportista_Accionista;
import com.reglamb.projvehimerc.domain.transportista.Transportista_Representante;
import com.reglamb.projvehimerc.domain.transportista.Transportista_Sucursal;

@Entity
@Table (name ="TRANSPORTISTA_JURIDICO")
//@PrimaryKeyJoinColumn(name = "`Id_transportista`")
public class TransportistaJuridico extends Transportista implements Serializable,DomainObject{

	private static final long serialVersionUID = 1L;
	private String razonsocial;
	private String constitucion;
	private Set<Transportista_Representante> representanteTransportista = new HashSet<Transportista_Representante>();
	private Set<Transportista_Accionista> accionistaTransportista = new HashSet<Transportista_Accionista>();
	private Set<Transportista_Sucursal> sucursalTransportista = new HashSet<Transportista_Sucursal>();
	
	public String getRazonsocial() {
		return razonsocial;
	}
	public void setRazonsocial(String razonsocial) {
		this.razonsocial = razonsocial;
	}
	public String getConstitucion() {
		return constitucion;
	}
	public void setConstitucion(String constitucion) {
		this.constitucion = constitucion;
	}
	@OneToMany(targetEntity=Transportista_Representante.class,
			orphanRemoval = true,cascade={javax.persistence.CascadeType.ALL})
			@JoinColumn(name="`Id_transportista`")
	public Set<Transportista_Representante> getRepresentanteTransportista() {
		return representanteTransportista;
	}
	
	public void setRepresentanteTransportista(
			Set<Transportista_Representante> representanteTransportista) {
		this.representanteTransportista = representanteTransportista;
	}
	@OneToMany(targetEntity=Transportista_Accionista.class,
			orphanRemoval = true,cascade={javax.persistence.CascadeType.ALL})
			@JoinColumn(name="`Id_transportista`")
	public Set<Transportista_Accionista> getAccionistaTransportista() {
		return accionistaTransportista;
	}
	public void setAccionistaTransportista(
			Set<Transportista_Accionista> accionistaTransportista) {
		this.accionistaTransportista = accionistaTransportista;
	}
	
	@OneToMany(targetEntity=Transportista_Sucursal.class,
			orphanRemoval = true,cascade={javax.persistence.CascadeType.ALL})
			@JoinColumn(name="`Id_transportista`")
	public Set<Transportista_Sucursal> getSucursalTransportista() {
		return sucursalTransportista;
	}
	public void setSucursalTransportista(
			Set<Transportista_Sucursal> sucursalTransportista) {
		this.sucursalTransportista = sucursalTransportista;
	}

}
