package com.reglamb.projvehimerc.domain;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
//import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Citv;
import com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Soat;
import com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Tenencia;

/**
 * @uml.dependency   supplier="com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Soat"
 * @uml.dependency   supplier="com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Citv"
 * @uml.dependency   supplier="com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Tenencia"
 */
@Entity
@SequenceGenerator(
	    name="SEQ_STORE",
	    sequenceName="sequencevehiculo",
	    initialValue= 100 ,
	    allocationSize=20)
@Table(name ="VEHICULO")
public class Vehiculo implements Serializable,DomainObject {
	private static final long serialVersionUID = 1L;
	
	private Long id_vehiculo;
	private String marca;
	private String modelo;
	private String clase;
	private String carroceria;
	private Date año_fab;
	private Integer n_chasis;
	private Integer n_ejes;
	private String combustible;
	private Float peso_seco;
	private Float carga_util;
	private String largo;
	private String ancho;
	private String altura;
	private Transportista transportista;
	/*Relacion One To One*/
	private Vehiculo_Citv vehiccitv;
	private Vehiculo_Soat vehicsoat;
	private Vehiculo_Tenencia vehictenec;
	@Id @GeneratedValue(strategy=GenerationType.SEQUENCE, generator="SEQ_STORE")
	@Column(name ="`Id_Vehiculo`")
	public Long getId_vehiculo() {
		return id_vehiculo;
	}
	public void setId_vehiculo(Long id_vehiculo) {
		this.id_vehiculo = id_vehiculo;
	}
	@Column(name="`Marca`")
	public String getMarca() {
		return marca;
	}
	public void setMarca(String marca) {
		this.marca = marca;
	}
	@Column(name="`Modelo`")
	public String getModelo() {
		return modelo;
	}
	public void setModelo(String modelo) {
		this.modelo = modelo;
	}
	public String getClase() {
		return clase;
	}
	public void setClase(String clase) {
		this.clase = clase;
	}
	public String getCarroceria() {
		return carroceria;
	}
	public void setCarroceria(String carroceria) {
		this.carroceria = carroceria;
	}
	public Date getAño_fab() {
		return año_fab;
	}
	public void setAño_fab(Date año_fab) {
		this.año_fab = año_fab;
	}
	public Integer getN_chasis() {
		return n_chasis;
	}
	public void setN_chasis(Integer n_chasis) {
		this.n_chasis = n_chasis;
	}
	public Integer getN_ejes() {
		return n_ejes;
	}
	public void setN_ejes(Integer n_ejes) {
		this.n_ejes = n_ejes;
	}
	public String getCombustible() {
		return combustible;
	}
	public void setCombustible(String combustible) {
		this.combustible = combustible;
	}
	public Float getPeso_seco() {
		return peso_seco;
	}
	public void setPeso_seco(Float peso_seco) {
		this.peso_seco = peso_seco;
	}
	public Float getCarga_util() {
		return carga_util;
	}
	public void setCarga_util(Float carga_util) {
		this.carga_util = carga_util;
	}
	public String getLargo() {
		return largo;
	}
	public void setLargo(String largo) {
		this.largo = largo;
	}
	public String getAncho() {
		return ancho;
	}
	public void setAncho(String ancho) {
		this.ancho = ancho;
	}
	public String getAltura() {
		return altura;
	}
	public void setAltura(String altura) {
		this.altura = altura;
	}
	/*Transportista ---> */
	@ManyToOne
	@JoinColumn(name="`Id_transportista`", nullable=false)
	//@JoinColumn(name="`Id_Vehiculo`", insertable=false, updatable=false)
	public Transportista getTransportista() {
		return transportista;
	}
	public void setTransportista(Transportista transportista) {
		this.transportista = transportista;
	}
	
	@OneToOne(cascade={javax.persistence.CascadeType.ALL},orphanRemoval = true)
    @JoinColumn(name = "`Id_vehi_Citv`",nullable=false)
	public Vehiculo_Citv getVehiccitv() {
		return vehiccitv;
	}
	public void setVehiccitv(Vehiculo_Citv vehiccitv) {
		this.vehiccitv = vehiccitv;
	}
	@OneToOne(cascade={javax.persistence.CascadeType.ALL},orphanRemoval = true)
    @JoinColumn(name = "`Id_vehi_Soat`",nullable=false)
	public Vehiculo_Soat getVehicsoat() {
		return vehicsoat;
	}
	public void setVehicsoat(Vehiculo_Soat vehicsoat) {
		this.vehicsoat = vehicsoat;
	}
	@OneToOne(cascade={javax.persistence.CascadeType.ALL},orphanRemoval = true)
    @JoinColumn(name = "`Id_vehi_Tenencia`",nullable=false)
	public Vehiculo_Tenencia getVehictenec() {
		return vehictenec;
	}
	public void setVehictenec(Vehiculo_Tenencia vehictenec) {
		this.vehictenec = vehictenec;
	}
    
}
