package com.reglamb.projvehimerc.domain.transportista;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.reglamb.projvehimerc.domain.DomainObject;
import com.reglamb.projvehimerc.domain.TransportistaJuridico;

@Entity
@SequenceGenerator(
	    name="SEQ_STORE",
	    sequenceName="sequenceaccionista",
	    initialValue= 100 ,
	    allocationSize=20)
@Table(name="ACCIONISTA")
public class Transportista_Accionista implements Serializable,DomainObject {
	private static final long serialVersionUID = 1L;
	private Long idtransportistaaccionista;
	private Long ruc;
	private String razonsocial;
	private int dni;
	private Date fech_ingreso;
	private String direccion;
	private Float participacion;
	private TransportistaJuridico transportistajuridico;
	@Id @GeneratedValue(strategy=GenerationType.SEQUENCE, generator="SEQ_STORE")
	@Column(name="`Id_transportista_accionista`")
	public Long getIdtransportistaaccionista() {
		return idtransportistaaccionista;
	}
	public void setIdtransportistaaccionista(Long idtransportistaaccionista) {
		this.idtransportistaaccionista = idtransportistaaccionista;
	}
	public Long getRuc() {
		return ruc;
	}
	public void setRuc(Long ruc) {
		this.ruc = ruc;
	}
	public String getRazonsocial() {
		return razonsocial;
	}
	public void setRazonsocial(String razonsocial) {
		this.razonsocial = razonsocial;
	}
	public int getDni() {
		return dni;
	}
	public void setDni(int dni) {
		this.dni = dni;
	}
	public Date getFech_ingreso() {
		return fech_ingreso;
	}
	public void setFech_ingreso(Date fech_ingreso) {
		this.fech_ingreso = fech_ingreso;
	}
	public String getDireccion() {
		return direccion;
	}
	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}
	public Float getParticipacion() {
		return participacion;
	}
	public void setParticipacion(Float participacion) {
		this.participacion = participacion;
	}
	@ManyToOne
	@JoinColumn(name="`Id_transportista`")
	public TransportistaJuridico getTransportistajuridico() {
		return transportistajuridico;
	}
	public void setTransportistajuridico(
			TransportistaJuridico transportistajuridico) {
		this.transportistajuridico = transportistajuridico;
	}
	
}
