package com.reglamb.projvehimerc.domain.transportista;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.reglamb.projvehimerc.domain.DomainObject;
import com.reglamb.projvehimerc.domain.TransportistaJuridico;
@Entity
@SequenceGenerator(
	    name="SEQ_STORE",
	    sequenceName="sequencerepresentante",
	    initialValue= 100 ,
	    allocationSize=20)
@Table(name="REPRESENTATE")
public class Transportista_Representante implements Serializable,DomainObject{

	private static final long serialVersionUID = 1L;
	private Long idtransportistarepresentate;
	private Long ruc;
	private Date fech_ingreso;
	private String direccion;
	private String telefono;
	private String correo_electronico;
	private TransportistaJuridico transportistajuridico;
	
	@Id @GeneratedValue(strategy=GenerationType.SEQUENCE, generator="SEQ_STORE")
	@Column(name ="`Id_transportista_representante`")
	public Long getIdtransportistarepresentate() {
		return idtransportistarepresentate;
	}
	public void setIdtransportistarepresentate(Long idtransportistarepresentate) {
		this.idtransportistarepresentate = idtransportistarepresentate;
	}
	public Long getRuc() {
		return ruc;
	}
	public void setRuc(Long ruc) {
		this.ruc = ruc;
	}
	public Date getFech_ingreso() {
		return fech_ingreso;
	}
	public void setFech_ingreso(Date fech_ingreso) {
		this.fech_ingreso = fech_ingreso;
	}
	public String getDireccion() {
		return direccion;
	}
	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}
	public String getTelefono() {
		return telefono;
	}
	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}
	public String getCorreo_electronico() {
		return correo_electronico;
	}
	public void setCorreo_electronico(String correo_electronico) {
		this.correo_electronico = correo_electronico;
	}
	@ManyToOne
	@JoinColumn(name="`Id_transportista`", nullable=true)
	public TransportistaJuridico getTransportistajuridico() {
		return transportistajuridico;
	}
	public void setTransportistajuridico(TransportistaJuridico transportistajuridico) {
		this.transportistajuridico = transportistajuridico;
	}	

}
