package com.reglamb.projvehimerc.domain.transportista;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.reglamb.projvehimerc.domain.DomainObject;
import com.reglamb.projvehimerc.domain.TransportistaJuridico;

@Entity
@SequenceGenerator(
	    name="SEQ_STORE",
	    sequenceName="sequencesucursal",
	    initialValue= 100 ,
	    allocationSize=20)
@Table(name = "SUCURSAL")
public class Transportista_Sucursal implements Serializable, DomainObject {
	private static final long serialVersionUID = 1L;
	private Long idtransportistasucursal;
	private Long ruc;
	private Date fech_ingreso;
	private String telefono;
	private String correo;
	private TransportistaJuridico transportistajuridico;
	@Id @GeneratedValue(strategy=GenerationType.SEQUENCE, generator="SEQ_STORE")
	@Column(name ="`Id_transportista_sucursal`")
	public Long getIdtransportistasucursal() {
		return idtransportistasucursal;
	}
	public void setIdtransportistasucursal(Long idtransportistasucursal) {
		this.idtransportistasucursal = idtransportistasucursal;
	}
	public Long getRuc() {
		return ruc;
	}
	public void setRuc(Long ruc) {
		this.ruc = ruc;
	}
	public Date getFech_ingreso() {
		return fech_ingreso;
	}
	public void setFech_ingreso(Date fech_ingreso) {
		this.fech_ingreso = fech_ingreso;
	}
	public String getTelefono() {
		return telefono;
	}
	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}
	public String getCorreo() {
		return correo;
	}
	public void setCorreo(String correo) {
		this.correo = correo;
	}
	@ManyToOne
	@JoinColumn(name="`Id_transportista`")
	public TransportistaJuridico getTransportistajuridico() {
		return transportistajuridico;
	}
	public void setTransportistajuridico(
			TransportistaJuridico transportistajuridico) {
		this.transportistajuridico = transportistajuridico;
	}
}
