package com.reglamb.projvehimerc.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.reglamb.projvehimerc.dao.ConductorDao;
import com.reglamb.projvehimerc.dao.HabilitacionVehicular_InscripcionDao;
import com.reglamb.projvehimerc.dao.TransportistaJuridicoDao;
import com.reglamb.projvehimerc.dao.TransportistaNaturalDao;
import com.reglamb.projvehimerc.dao.Transportista_AccionistaDao;
import com.reglamb.projvehimerc.dao.Transportista_RepresentanteDao;
import com.reglamb.projvehimerc.dao.Transportista_SucursalDao;
import com.reglamb.projvehimerc.dao.Transportista_UbigeoDao;
import com.reglamb.projvehimerc.dao.VehiculoDao;
import com.reglamb.projvehimerc.dao.Vehiculo_CitvDao;
import com.reglamb.projvehimerc.dao.Vehiculo_SoatDao;
import com.reglamb.projvehimerc.dao.Vehiculo_TenenciaDao;
import com.reglamb.projvehimerc.domain.Conductor;
import com.reglamb.projvehimerc.domain.HabilitacionVehicular_Inscripcion;
import com.reglamb.projvehimerc.domain.TransportistaJuridico;
import com.reglamb.projvehimerc.domain.TransportistaNatural;
import com.reglamb.projvehimerc.domain.Transportista_Ubigeo;
import com.reglamb.projvehimerc.domain.Vehiculo;
import com.reglamb.projvehimerc.domain.transportista.Transportista_Accionista;
import com.reglamb.projvehimerc.domain.transportista.Transportista_Representante;
import com.reglamb.projvehimerc.domain.transportista.Transportista_Sucursal;
import com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Citv;
import com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Soat;
import com.reglamb.projvehimerc.domain.vehiculo.Vehiculo_Tenencia;


@Service(value = "inscripcionHabilitacionVehicFacade")
@Transactional
public class HabilitacionVehicular_InscripcionFacadeImpl implements HabilitacionVehicular_InscripcionFacade{
	/*Dao's*/
	HabilitacionVehicular_InscripcionDao habilitacionVehicular_InscripcionDao;
	TransportistaJuridicoDao transportistaJuridicoDao;
	TransportistaNaturalDao transportistaNaturalDao;
	Transportista_SucursalDao transportistaSucursalDao;
	Transportista_RepresentanteDao transportistaRepresentanteDao;
	Transportista_AccionistaDao transportistaAccionistaDao;
	Transportista_UbigeoDao transportistaUbigeoDao;
	VehiculoDao vehiculoDao;
	Vehiculo_CitvDao vehiculoCitvDao;
	Vehiculo_SoatDao vehiculoSoatDao;
	Vehiculo_TenenciaDao vehiculoTenenciaDao;
	ConductorDao conductorDao;
	
	
	/*Habilitacion Vehicular Inscripcion*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveHabilitacionVehicularInscrip(
			HabilitacionVehicular_Inscripcion habilitacioninscrip) {
		habilitacionVehicular_InscripcionDao.saveHabilitacionVehicularInscrip(habilitacioninscrip);
	}

	@Transactional(readOnly = true)
	public List<HabilitacionVehicular_Inscripcion> getAllHabilitacionVehicularInscrip(
			HabilitacionVehicular_Inscripcion habilitacioninscrip) {
		return habilitacionVehicular_InscripcionDao.getAllHabilitacionVehicularInscrip(habilitacioninscrip);
	}
	
	/*Transportista Juridico*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveTransportistaJuridDao(
			TransportistaJuridico transportistajurid)
			throws DataAccessException {
		transportistaJuridicoDao.saveTransportistaJuridDao(transportistajurid);
	}

	@Transactional(readOnly = true)
	public List<TransportistaJuridico> getAllTransportistaJuridDao(
			TransportistaJuridico transportistajurid)
			throws DataAccessException {
		return transportistaJuridicoDao.getAllTransportistaJuridDao(transportistajurid);
	}
	
	/*Transportista Natural*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveTransportistaNatuDao(TransportistaNatural transportistanatu) {
		transportistaNaturalDao.saveTransportistaNatuDao(transportistanatu);
	}
	
	@Transactional(readOnly = true)
	public List<TransportistaNatural> getAllTransportistaNatuDao(
			TransportistaNatural transportistanatu) throws DataAccessException {
		return transportistaNaturalDao.getAllTransportistaNatuDao(transportistanatu);
	}
	
	/*Transportista Sucursal*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveTransportistaSucursal(
			Transportista_Sucursal transportistasucu)
			throws DataAccessException {
		transportistaSucursalDao.saveTransportistaSucursal(transportistasucu);
	}
	
	@Transactional(readOnly = true)
	public List<Transportista_Sucursal> getAllTransportistaSucursal(
			Transportista_Sucursal transportistasucu)
			throws DataAccessException {
		return transportistaSucursalDao.getAllTransportistaSucursal(transportistasucu);
	}
	
	/*Transportista Representante*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveTransportistaRepresentate(
			Transportista_Representante transportistarepre)
			throws DataAccessException {
		transportistaRepresentanteDao.saveTransportistaRepresentate(transportistarepre);		
	}

	@Transactional(readOnly = true)
	public List<Transportista_Representante> getAllTransportistaRepresentate(
			Transportista_Representante transportistarepre)
			throws DataAccessException {
		return transportistaRepresentanteDao.getAllTransportistaRepresentate(transportistarepre);
	}
	
	/*Transportista Accionista*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveTransportistaAccionista(
			Transportista_Accionista transportistasaccio)
			throws DataAccessException {
		transportistaAccionistaDao.saveTransportistaAccionista(transportistasaccio);
	}
	
	@Transactional(readOnly = true)
	public List<Transportista_Accionista> getAllTransportistaAccionista(
			Transportista_Accionista transportistasaccio)
			throws DataAccessException {
		return transportistaAccionistaDao.getAllTransportistaAccionista(transportistasaccio);
	}
	
	/*Transportista Ubigeo*/
	@Transactional(readOnly = false)
	public void saveTransportistaubi(Transportista_Ubigeo transportistaubi)
			throws DataAccessException {
		transportistaUbigeoDao.saveTransportistaubi(transportistaubi);
	}

	@Transactional(readOnly = true)
	public List<Transportista_Ubigeo> getAllTransportistaubi(
			Transportista_Ubigeo transportistaubi) throws DataAccessException {
		return transportistaUbigeoDao.getAllTransportistaubi(transportistaubi);
	}
	
	/*Vehiculo*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveVehiculo(Vehiculo vehiculo) throws DataAccessException {
		vehiculoDao.saveVehiculo(vehiculo);
	}

	@Transactional(readOnly = true)
	public List<Vehiculo> getAllVehiculo(Vehiculo vehiculo)
			throws DataAccessException {
		return vehiculoDao.getAllVehiculo(vehiculo);
	}
	
	/*Vehiculo Citv*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveVehiculoCitv(Vehiculo_Citv vehiculocitv)
			throws DataAccessException {
		vehiculoCitvDao.saveVehiculoCitv(vehiculocitv);
	}

	@Transactional(readOnly = true)
	public List<Vehiculo_Citv> getAllVehiculoCitv(Vehiculo_Citv vehiculocitv)
			throws DataAccessException {
		return vehiculoCitvDao.getAllVehiculoCitv(vehiculocitv);
	}
	
	/*Vehiculo Soat*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveVehiculoSoat(Vehiculo_Soat vehiculosoat)
			throws DataAccessException {
		vehiculoSoatDao.saveVehiculoSoat(vehiculosoat);	
	}
	@Transactional(readOnly = true)
	public List<Vehiculo_Soat> getAllVehiculoSoat(Vehiculo_Soat vehiculosoat)
			throws DataAccessException {
		return vehiculoSoatDao.getAllVehiculoSoat(vehiculosoat);
	}

	/*Vehiculo Tenencia*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveVehiculoTenencia(Vehiculo_Tenencia vehiculotenencia)
			throws DataAccessException {
		vehiculoTenenciaDao.saveVehiculoTenencia(vehiculotenencia);
	}

	@Transactional(readOnly = true)
	public List<Vehiculo_Tenencia> getAllVehiculoTenencia(
			Vehiculo_Tenencia vehiculotenencia) throws DataAccessException {
		return vehiculoTenenciaDao.getAllVehiculoTenencia(vehiculotenencia);
	}
	
	/*Conductor*/
	@Transactional(readOnly = false,isolation=Isolation.DEFAULT)
	public void saveConductor(Conductor conductor) throws DataAccessException {
		conductorDao.saveConductor(conductor);
	}

	@Transactional(readOnly = true)
	public List<Conductor> getAllConductor(Conductor conductor)
			throws DataAccessException {
		return conductorDao.getAllConductor(conductor);
	}

	public Vehiculo_SoatDao getVehiculoSoatDao() {
		return vehiculoSoatDao;
	}
	@Autowired
	public void setVehiculoSoatDao(Vehiculo_SoatDao vehiculoSoatDao) {
		this.vehiculoSoatDao = vehiculoSoatDao;
	}



}
